#ifndef __JABYENGINE_INTERNAL_SIMPLE_HELPER_HPP__
#define __JABYENGINE_INTERNAL_SIMPLE_HELPER_HPP__
#define private public
#include <PSX/File/Processor/File_Processor.hpp>

namespace FileProcessor {
    namespace Helper {
        template<typename T>
        static void simple_read(T& dst, State::Configuration& config) {
            static constexpr size_t UINT32_SIZE = (sizeof(T)/sizeof(uint32_t));

            dst = *reinterpret_cast<const T*>(config.data_adr);
            config.processed(UINT32_SIZE);

            static_assert((UINT32_SIZE*sizeof(uint32_t)) == sizeof(T));
        }

        template<typename T>
        static bool exchange_and_execute_process_function(bool (*process_routine)(State::Configuration&, T&), State::Configuration& config, T& state) {
            config.process_routine = reinterpret_cast<State::ProcessRoutine>(process_routine);
            return process_routine(config, state);
        }
    }
}

#endif // !__JABYENGINE_INTERNAL_SIMPLE_HELPER_HPP__